Index: branches/Ticket175Branch/HeuristicLab.Data/ArrayDataBaseView.Designer.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/ArrayDataBaseView.Designer.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/ArrayDataBaseView.Designer.cs	(revision 343)
@@ -105,5 +105,5 @@
     private System.Windows.Forms.Label sizeLabel;
     private System.Windows.Forms.TextBox lengthTextBox;
-    private System.Windows.Forms.DataGridView dataGridView;
+    protected System.Windows.Forms.DataGridView dataGridView;
   }
 }
Index: branches/Ticket175Branch/HeuristicLab.Data/ArrayDataBaseView.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/ArrayDataBaseView.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/ArrayDataBaseView.cs	(revision 343)
@@ -64,5 +64,5 @@
         dataGridView.RowCount = length;
         for (int i = 0; i < length; i++) {
-          dataGridView.Rows[i].Cells[0].Value = ArrayDataBase.Data.GetValue(i); ;
+          dataGridView.Rows[i].Cells[0].Value = ArrayDataBase.Data.GetValue(i);
         }
       } else {
Index: branches/Ticket175Branch/HeuristicLab.Data/ConstrainedDoubleDataView.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/ConstrainedDoubleDataView.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/ConstrainedDoubleDataView.cs	(revision 343)
@@ -62,5 +62,5 @@
       } else {
         dataTextBox.Enabled = true;
-        dataTextBox.Text = ConstrainedDoubleData.ToString();
+        dataTextBox.Text = ConstrainedDoubleData.Data.ToString("r");
       }
     }
Index: branches/Ticket175Branch/HeuristicLab.Data/DoubleArrayData.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/DoubleArrayData.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/DoubleArrayData.cs	(revision 343)
@@ -65,5 +65,5 @@
       for(int i = 0; i < Data.Length; i++) {
         builder.Append(";");
-        builder.Append(Data[i].ToString(format));
+        builder.Append(Data[i].ToString("r", format));
       }
       if(builder.Length > 0)
Index: branches/Ticket175Branch/HeuristicLab.Data/DoubleArrayDataView.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/DoubleArrayDataView.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/DoubleArrayDataView.cs	(revision 343)
@@ -37,4 +37,6 @@
     public DoubleArrayDataView() {
       InitializeComponent();
+      // round-trip format for all cells
+      dataGridView.DefaultCellStyle.Format = "r";
     }
     public DoubleArrayDataView(DoubleArrayData doubleArrayData)
Index: branches/Ticket175Branch/HeuristicLab.Data/DoubleData.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/DoubleData.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/DoubleData.cs	(revision 343)
@@ -54,5 +54,5 @@
     public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid,IStorable> persistedObjects) {
       XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-      node.InnerText = Data.ToString(CultureInfo.InvariantCulture.NumberFormat);
+      node.InnerText = Data.ToString("r", CultureInfo.InvariantCulture.NumberFormat);
       return node;
     }
Index: branches/Ticket175Branch/HeuristicLab.Data/DoubleDataView.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/DoubleDataView.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/DoubleDataView.cs	(revision 343)
@@ -59,5 +59,5 @@
       } else {
         dataTextBox.Enabled = true;
-        dataTextBox.Text = DoubleData.ToString();
+        dataTextBox.Text = DoubleData.Data.ToString("r");
       }
     }
Index: branches/Ticket175Branch/HeuristicLab.Data/DoubleMatrixData.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/DoubleMatrixData.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/DoubleMatrixData.cs	(revision 343)
@@ -81,5 +81,5 @@
         for (int j = 0; j < Data.GetLength(1); j++) {
           builder.Append(";");
-          builder.Append(Data[i, j].ToString(format));
+          builder.Append(Data[i, j].ToString("r", format));
         }
       }
Index: branches/Ticket175Branch/HeuristicLab.Data/DoubleMatrixDataView.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/DoubleMatrixDataView.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/DoubleMatrixDataView.cs	(revision 343)
@@ -37,4 +37,6 @@
     public DoubleMatrixDataView() {
       InitializeComponent();
+      // round-trip format for all cells
+      dataGridView.DefaultCellStyle.Format = "r";
     }
     public DoubleMatrixDataView(DoubleMatrixData doubleMatrixData)
Index: branches/Ticket175Branch/HeuristicLab.Data/MatrixDataBaseView.Designer.cs
===================================================================
--- branches/Ticket175Branch/HeuristicLab.Data/MatrixDataBaseView.Designer.cs	(revision 342)
+++ branches/Ticket175Branch/HeuristicLab.Data/MatrixDataBaseView.Designer.cs	(revision 343)
@@ -132,5 +132,5 @@
     private System.Windows.Forms.Label rowsLabel;
     private System.Windows.Forms.TextBox rowsTextBox;
-    private System.Windows.Forms.DataGridView dataGridView;
+    protected System.Windows.Forms.DataGridView dataGridView;
     private System.Windows.Forms.TextBox columnsTextBox;
     private System.Windows.Forms.Label columnsLabel;