Index: trunk/sources/HeuristicLab.CEDMA.Core/Agent.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/Agent.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/Agent.cs	(revision 377)
@@ -28,5 +28,5 @@
 using HeuristicLab.CEDMA.DB.Interfaces;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public class Agent : ItemBase, IAgent {
     public IDatabase Database { get; set; }
@@ -45,5 +45,6 @@
     }
 
-    public Agent(IDatabase database, long id) : this() {
+    public Agent(IDatabase database, long id)
+      : this() {
       Database = database;
       Id = id;
Index: trunk/sources/HeuristicLab.CEDMA.Core/AgentList.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/AgentList.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/AgentList.cs	(revision 377)
@@ -31,5 +31,5 @@
 using System.IO;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public class AgentList : ItemBase, IAgentList {
     private string serverUri;
Index: trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.Designer.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.Designer.cs	(revision 377)
@@ -23,5 +23,5 @@
 using System.Windows.Forms;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   partial class AgentListView {
     /// <summary>
@@ -35,5 +35,5 @@
     /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
     protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
+      if(disposing && (components != null)) {
         components.Dispose();
       }
Index: trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.cs	(revision 377)
@@ -29,5 +29,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public partial class AgentListView : ViewBase {
     private ChooseItemDialog chooseItemDialog;
Index: trunk/sources/HeuristicLab.CEDMA.Core/AgentView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/AgentView.Designer.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/AgentView.Designer.cs	(revision 377)
@@ -20,5 +20,5 @@
 #endregion
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   partial class AgentView {
     /// <summary> 
@@ -32,5 +32,5 @@
     /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
     protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
+      if(disposing && (components != null)) {
         components.Dispose();
       }
Index: trunk/sources/HeuristicLab.CEDMA.Core/AgentView.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/AgentView.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/AgentView.cs	(revision 377)
@@ -30,5 +30,5 @@
 using HeuristicLab.CEDMA.DB.Interfaces;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public partial class AgentView : ViewBase {
     public IAgent Agent {
Index: trunk/sources/HeuristicLab.CEDMA.Core/Console.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 377)
@@ -30,5 +30,5 @@
 using HeuristicLab.CEDMA.DB.Interfaces;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public class Console : ItemBase, IEditable {
     private AgentList agentList;
Index: trunk/sources/HeuristicLab.CEDMA.Core/ConsoleEditor.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/ConsoleEditor.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/ConsoleEditor.cs	(revision 377)
@@ -28,5 +28,5 @@
 using System.ServiceModel;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   class ConsoleEditor : EditorBase {
     private System.Windows.Forms.TextBox uriTextBox;
Index: trunk/sources/HeuristicLab.CEDMA.Core/DbPersistenceManager.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/DbPersistenceManager.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/DbPersistenceManager.cs	(revision 377)
@@ -28,5 +28,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public static class DbPersistenceManager {
     public static IStorable Restore(byte[] serializedStorable) {
Index: trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Console.csproj
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Console.csproj	(revision 376)
+++ 	(revision )
@@ -1,125 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
-  <PropertyGroup>
-    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
-    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.21022</ProductVersion>
-    <SchemaVersion>2.0</SchemaVersion>
-    <ProjectGuid>{F8880599-F224-4EC7-9288-5C4A6853E7BE}</ProjectGuid>
-    <OutputType>Library</OutputType>
-    <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab.CEDMA.Console</RootNamespace>
-    <AssemblyName>HeuristicLab.CEDMA.Console</AssemblyName>
-    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
-    <FileAlignment>512</FileAlignment>
-    <SignAssembly>true</SignAssembly>
-    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
-    <DebugSymbols>true</DebugSymbols>
-    <DebugType>full</DebugType>
-    <Optimize>false</Optimize>
-    <OutputPath>bin\Debug\</OutputPath>
-    <DefineConstants>DEBUG;TRACE</DefineConstants>
-    <ErrorReport>prompt</ErrorReport>
-    <WarningLevel>4</WarningLevel>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
-    <DebugType>pdbonly</DebugType>
-    <Optimize>true</Optimize>
-    <OutputPath>bin\Release\</OutputPath>
-    <DefineConstants>TRACE</DefineConstants>
-    <ErrorReport>prompt</ErrorReport>
-    <WarningLevel>4</WarningLevel>
-  </PropertyGroup>
-  <ItemGroup>
-    <Reference Include="HeuristicLab.PluginInfrastructure, Version=3.0.0.316, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\..\..\Program Files\HeuristicLab 3.0\HeuristicLab.PluginInfrastructure.dll</HintPath>
-    </Reference>
-    <Reference Include="System" />
-    <Reference Include="System.Core">
-      <RequiredTargetFramework>3.5</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.Drawing" />
-    <Reference Include="System.Runtime.Serialization">
-      <RequiredTargetFramework>3.0</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.ServiceModel">
-      <RequiredTargetFramework>3.0</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Xml.Linq">
-      <RequiredTargetFramework>3.5</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.Data.DataSetExtensions">
-      <RequiredTargetFramework>3.5</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.Data" />
-    <Reference Include="System.Xml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Compile Include="Agent.cs" />
-    <Compile Include="AgentList.cs" />
-    <Compile Include="Console.cs" />
-    <Compile Include="ConsoleEditor.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="DbPersistenceManager.cs" />
-    <Compile Include="HeuristicLabCedmaConsolePlugin.cs" />
-    <Compile Include="IAgent.cs" />
-    <Compile Include="IAgentList.cs" />
-    <Compile Include="IDatabaseItem.cs" />
-    <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="AgentListView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="AgentListView.Designer.cs">
-      <DependentUpon>AgentListView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="AgentView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="AgentView.Designer.cs">
-      <DependentUpon>AgentView.cs</DependentUpon>
-    </Compile>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="HeuristicLab.snk" />
-  </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\HeuristicLab.CEDMA.DB.Interfaces\HeuristicLab.CEDMA.DB.Interfaces.csproj">
-      <Project>{4F9BB789-D561-436B-B226-2BF44B7D0804}</Project>
-      <Name>HeuristicLab.CEDMA.DB.Interfaces</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Core\HeuristicLab.Core.csproj">
-      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
-      <Name>HeuristicLab.Core</Name>
-    </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="AgentListView.resx">
-      <DependentUpon>AgentListView.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="AgentView.resx">
-      <DependentUpon>AgentView.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="ConsoleEditor.resx">
-      <DependentUpon>ConsoleEditor.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-  </ItemGroup>
-  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
-  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
-       Other similar extension points exist, see Microsoft.Common.targets.
-  <Target Name="BeforeBuild">
-  </Target>
-  <Target Name="AfterBuild">
-  </Target>
-  -->
-  <PropertyGroup>
-    <PreBuildEvent>cmd /c ..\..\..\PreBuildEvent.cmd</PreBuildEvent>
-  </PropertyGroup>
-</Project>
Index: trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Core.csproj
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Core.csproj	(revision 377)
+++ trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Core.csproj	(revision 377)
@@ -0,0 +1,125 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.21022</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{C27DDF6C-84DF-45EF-B82F-57A28DD51166}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.CEDMA.Core</RootNamespace>
+    <AssemblyName>HeuristicLab.CEDMA.Core</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.PluginInfrastructure, Version=3.0.0.316, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\..\..\..\Program Files\HeuristicLab 3.0\HeuristicLab.PluginInfrastructure.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Runtime.Serialization">
+      <RequiredTargetFramework>3.0</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.ServiceModel">
+      <RequiredTargetFramework>3.0</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Agent.cs" />
+    <Compile Include="AgentList.cs" />
+    <Compile Include="Console.cs" />
+    <Compile Include="ConsoleEditor.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="DbPersistenceManager.cs" />
+    <Compile Include="HeuristicLabCedmaCorePlugin.cs" />
+    <Compile Include="IAgent.cs" />
+    <Compile Include="IAgentList.cs" />
+    <Compile Include="IDatabaseItem.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="AgentListView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="AgentListView.Designer.cs">
+      <DependentUpon>AgentListView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="AgentView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="AgentView.Designer.cs">
+      <DependentUpon>AgentView.cs</DependentUpon>
+    </Compile>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.CEDMA.DB.Interfaces\HeuristicLab.CEDMA.DB.Interfaces.csproj">
+      <Project>{4F9BB789-D561-436B-B226-2BF44B7D0804}</Project>
+      <Name>HeuristicLab.CEDMA.DB.Interfaces</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Core\HeuristicLab.Core.csproj">
+      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
+      <Name>HeuristicLab.Core</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="AgentListView.resx">
+      <DependentUpon>AgentListView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="AgentView.resx">
+      <DependentUpon>AgentView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="ConsoleEditor.resx">
+      <DependentUpon>ConsoleEditor.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PreBuildEvent>cmd /c ..\..\..\PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLabCedmaConsolePlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLabCedmaConsolePlugin.cs	(revision 376)
+++ 	(revision )
@@ -1,35 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.CEDMA.Console {
-  [ClassInfo(Name = "HeuristicLab.CEDMA.Console")]
-  [PluginFile(Filename = "HeuristicLab.CEDMA.Console.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core")]
-  [Dependency(Dependency = "HeuristicLab.CEDMA.DB.Interfaces")]
-  [Dependency(Dependency = "HeuristicLab.CEDMA.Server")]
-  public class HeuristicLabCedmaConsolePlugin : PluginBase {
-  }
-}
Index: trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLabCedmaCorePlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLabCedmaCorePlugin.cs	(revision 377)
+++ trunk/sources/HeuristicLab.CEDMA.Core/HeuristicLabCedmaCorePlugin.cs	(revision 377)
@@ -0,0 +1,35 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.CEDMA.Core {
+  [ClassInfo(Name = "HeuristicLab.CEDMA.Core")]
+  [PluginFile(Filename = "HeuristicLab.CEDMA.Core.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Core")]
+  [Dependency(Dependency = "HeuristicLab.CEDMA.DB.Interfaces")]
+  [Dependency(Dependency = "HeuristicLab.CEDMA.Server")]
+  public class HeuristicLabCedmaCorePlugin : PluginBase {
+  }
+}
Index: trunk/sources/HeuristicLab.CEDMA.Core/IAgent.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/IAgent.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/IAgent.cs	(revision 377)
@@ -27,5 +27,5 @@
 using HeuristicLab.CEDMA.DB.Interfaces;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public interface IAgent : IDatabaseItem {
     string Name { get; }
Index: trunk/sources/HeuristicLab.CEDMA.Core/IAgentList.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/IAgentList.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/IAgentList.cs	(revision 377)
@@ -26,5 +26,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public interface IAgentList : IItem, IEnumerable<IAgent> {
     void CreateAgent();
Index: trunk/sources/HeuristicLab.CEDMA.Core/IDatabaseItem.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/IDatabaseItem.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Core/IDatabaseItem.cs	(revision 377)
@@ -27,5 +27,5 @@
 using HeuristicLab.CEDMA.DB.Interfaces;
 
-namespace HeuristicLab.CEDMA.Console {
+namespace HeuristicLab.CEDMA.Core {
   public interface IDatabaseItem : IItem {
     IDatabase Database { get; set; }
Index: trunk/sources/HeuristicLab.CEDMA.Operators/HeuristicLab.CEDMA.Operators.csproj
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Operators/HeuristicLab.CEDMA.Operators.csproj	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Operators/HeuristicLab.CEDMA.Operators.csproj	(revision 377)
@@ -66,7 +66,7 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\HeuristicLab.CEDMA.Console\HeuristicLab.CEDMA.Console.csproj">
-      <Project>{F8880599-F224-4EC7-9288-5C4A6853E7BE}</Project>
-      <Name>HeuristicLab.CEDMA.Console</Name>
+    <ProjectReference Include="..\HeuristicLab.CEDMA.Core\HeuristicLab.CEDMA.Core.csproj">
+      <Project>{C27DDF6C-84DF-45EF-B82F-57A28DD51166}</Project>
+      <Name>HeuristicLab.CEDMA.Core</Name>
     </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.CEDMA.DB.Interfaces\HeuristicLab.CEDMA.DB.Interfaces.csproj">
Index: trunk/sources/HeuristicLab.CEDMA.Operators/OnGridProcessor.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Operators/OnGridProcessor.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Operators/OnGridProcessor.cs	(revision 377)
@@ -28,5 +28,5 @@
 using HeuristicLab.CEDMA.DB.Interfaces;
 using System.ServiceModel;
-using HeuristicLab.CEDMA.Console;
+using HeuristicLab.CEDMA.Core;
 
 namespace HeuristicLab.CEDMA.Operators {
Index: trunk/sources/HeuristicLab.CEDMA.Server/AgentScheduler.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Server/AgentScheduler.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Server/AgentScheduler.cs	(revision 377)
@@ -28,5 +28,5 @@
 using HeuristicLab.Core;
 using System.Threading;
-using HeuristicLab.CEDMA.Console;
+using HeuristicLab.CEDMA.Core;
 
 namespace HeuristicLab.CEDMA.Server {
Index: trunk/sources/HeuristicLab.CEDMA.Server/HeuristicLab.CEDMA.Server.csproj
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Server/HeuristicLab.CEDMA.Server.csproj	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Server/HeuristicLab.CEDMA.Server.csproj	(revision 377)
@@ -73,7 +73,7 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\HeuristicLab.CEDMA.Console\HeuristicLab.CEDMA.Console.csproj">
-      <Project>{F8880599-F224-4EC7-9288-5C4A6853E7BE}</Project>
-      <Name>HeuristicLab.CEDMA.Console</Name>
+    <ProjectReference Include="..\HeuristicLab.CEDMA.Core\HeuristicLab.CEDMA.Core.csproj">
+      <Project>{C27DDF6C-84DF-45EF-B82F-57A28DD51166}</Project>
+      <Name>HeuristicLab.CEDMA.Core</Name>
     </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.CEDMA.DB.Interfaces\HeuristicLab.CEDMA.DB.Interfaces.csproj">
Index: trunk/sources/HeuristicLab.CEDMA.Server/RunScheduler.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Server/RunScheduler.cs	(revision 376)
+++ trunk/sources/HeuristicLab.CEDMA.Server/RunScheduler.cs	(revision 377)
@@ -28,5 +28,5 @@
 using HeuristicLab.Core;
 using System.Threading;
-using HeuristicLab.CEDMA.Console;
+using HeuristicLab.CEDMA.Core;
 using HeuristicLab.Grid;
 
Index: trunk/sources/HeuristicLab.sln
===================================================================
--- trunk/sources/HeuristicLab.sln	(revision 376)
+++ trunk/sources/HeuristicLab.sln	(revision 377)
@@ -78,9 +78,9 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.DB", "HeuristicLab.CEDMA.DB\HeuristicLab.CEDMA.DB.csproj", "{B3D6D8D9-2B1F-47EC-9C73-77FAECF87310}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Console", "HeuristicLab.CEDMA.Console\HeuristicLab.CEDMA.Console.csproj", "{F8880599-F224-4EC7-9288-5C4A6853E7BE}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Operators", "HeuristicLab.CEDMA.Operators\HeuristicLab.CEDMA.Operators.csproj", "{6BC692D4-8843-4945-ACE4-5B41ED55476A}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Server", "HeuristicLab.CEDMA.Server\HeuristicLab.CEDMA.Server.csproj", "{F05D261A-4F7D-46C9-AB9C-21FD4566D719}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Core", "HeuristicLab.CEDMA.Core\HeuristicLab.CEDMA.Core.csproj", "{C27DDF6C-84DF-45EF-B82F-57A28DD51166}"
 EndProject
 Global
@@ -230,8 +230,4 @@
 		{B3D6D8D9-2B1F-47EC-9C73-77FAECF87310}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{B3D6D8D9-2B1F-47EC-9C73-77FAECF87310}.Release|Any CPU.Build.0 = Release|Any CPU
-		{F8880599-F224-4EC7-9288-5C4A6853E7BE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{F8880599-F224-4EC7-9288-5C4A6853E7BE}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{F8880599-F224-4EC7-9288-5C4A6853E7BE}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{F8880599-F224-4EC7-9288-5C4A6853E7BE}.Release|Any CPU.Build.0 = Release|Any CPU
 		{6BC692D4-8843-4945-ACE4-5B41ED55476A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{6BC692D4-8843-4945-ACE4-5B41ED55476A}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -242,4 +238,8 @@
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719}.Release|Any CPU.Build.0 = Release|Any CPU
+		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|Any CPU.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 376)
+++ trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 377)
@@ -10,5 +10,5 @@
 copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
 copy "..\..\..\HeuristicLab.BitVector\bin\%1\HeuristicLab.BitVector.dll" .\plugins
-copy "..\..\..\HeuristicLab.CEDMA.Console\bin\%1\HeuristicLab.CEDMA.Console.dll" .\plugins
+copy "..\..\..\HeuristicLab.CEDMA.Core\bin\%1\HeuristicLab.CEDMA.Core.dll" .\plugins
 copy "..\..\..\HeuristicLab.CEDMA.DB\bin\%1\HeuristicLab.CEDMA.DB.dll" .\plugins
 copy "..\..\..\HeuristicLab.CEDMA.DB.Interfaces\bin\%1\HeuristicLab.CEDMA.DB.Interfaces.dll" .\plugins