Index: /trunk/sources/HeuristicLab.CEDMA.Core/AgentList.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Core/AgentList.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.CEDMA.Core/AgentList.cs	(revision 383)
@@ -33,5 +33,4 @@
 namespace HeuristicLab.CEDMA.Core {
   public class AgentList : ItemBase, IAgentList {
-    private string serverUri;
     private List<IAgent> agentList;
     private IDatabase database;
Index: /trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.CEDMA.Core/AgentListView.cs	(revision 383)
@@ -31,6 +31,4 @@
 namespace HeuristicLab.CEDMA.Core {
   public partial class AgentListView : ViewBase {
-    private ChooseItemDialog chooseItemDialog;
-
     public IAgentList AgentList {
       get { return (IAgentList)Item; }
Index: /trunk/sources/HeuristicLab.CEDMA.Core/Console.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 383)
@@ -53,5 +53,5 @@
     }
 
-    public IView CreateView() {
+    public override IView CreateView() {
       return new ConsoleEditor(this);
     }
Index: /trunk/sources/HeuristicLab.CEDMA.Core/IAgent.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Core/IAgent.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.CEDMA.Core/IAgent.cs	(revision 383)
@@ -32,5 +32,4 @@
     ProcessStatus Status { get; }
     IOperatorGraph OperatorGraph { get; }
-    void Save();
     void Activate();
   }
Index: /trunk/sources/HeuristicLab.DistributedEngine/DistributedEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.DistributedEngine/DistributedEngine.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.DistributedEngine/DistributedEngine.cs	(revision 383)
@@ -37,5 +37,4 @@
   public class DistributedEngine : EngineBase, IEditable {
     private JobManager jobManager;
-    private CompositeOperation waitingOperations;
     private string serverAddress;
     public string ServerAddress {
Index: /trunk/sources/HeuristicLab.Grid/ClientForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Grid/ClientForm.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.Grid/ClientForm.cs	(revision 383)
@@ -111,5 +111,5 @@
         try {
           gotEngine = engineStore.TryTakeEngine(out currentGuid, out engineXml);
-        } catch(TimeoutException timeoutException) {
+        } catch(TimeoutException) {
           currentEngine = null;
           currentGuid = Guid.Empty;
@@ -117,5 +117,5 @@
           fetchOperationTimer.Interval = 5000;
           fetchOperationTimer.Start();
-        } catch(CommunicationException communicationException) {
+        } catch(CommunicationException) {
           // connection problem -> reset connection and start the timer again
           ResetConnection();
@@ -155,9 +155,9 @@
               engineStore.StoreResult(currentGuid, resultXml);
               success = true;
-            } catch(TimeoutException timeoutException) {
+            } catch(TimeoutException) {
               success = false;
               retries++;
               Thread.Sleep(TimeSpan.FromSeconds(CONNECTION_RETRY_TIMEOUT_SEC));
-            } catch(CommunicationException communicationException) {
+            } catch(CommunicationException) {
               ResetConnection();
               success = false;
Index: /trunk/sources/HeuristicLab.Grid/JobManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Grid/JobManager.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.Grid/JobManager.cs	(revision 383)
@@ -189,8 +189,8 @@
           }
           return;
-        } catch(TimeoutException timeoutException) {
-          retries++;
-          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
-        } catch(CommunicationException communicationException) {
+        } catch(TimeoutException) {
+          retries++;
+          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
+        } catch(CommunicationException) {
           ResetConnection();
           retries++;
@@ -208,8 +208,8 @@
             return zippedResult;
           }
-        } catch(TimeoutException timeoutException) {
-          retries++;
-          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
-        } catch(CommunicationException communicationException) {
+        } catch(TimeoutException) {
+          retries++;
+          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
+        } catch(CommunicationException) {
           ResetConnection();
           retries++;
@@ -229,8 +229,8 @@
             return jobState;
           }
-        } catch(TimeoutException timeoutException) {
-          retries++;
-          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
-        } catch(CommunicationException communicationException) {
+        } catch(TimeoutException) {
+          retries++;
+          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
+        } catch(CommunicationException) {
           ResetConnection();
           retries++;
Index: /trunk/sources/HeuristicLab.Grid/ProcessingEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Grid/ProcessingEngine.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.Grid/ProcessingEngine.cs	(revision 383)
@@ -63,5 +63,5 @@
         try {
           next = atomicOperation.Operator.Execute(atomicOperation.Scope);
-        } catch(Exception ex) {
+        } catch(Exception) {
           // push operation on stack again
           myExecutionStack.Push(atomicOperation);
Index: /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/PluginAction.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/PluginAction.cs	(revision 382)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/PluginAction.cs	(revision 383)
@@ -65,5 +65,4 @@
           // this method is not defined for actions other than "Install" and "Remove"
           throw new InvalidOperationException();
-          return "";
       }
     }